/*******************************************************************************
 * FoxDataProvider_Gear_Badge generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDataProvider_Gear_Badge extends FoxDataProvider_GearInfo
    transient
    native
    config(Badge)
    perobjectconfig
    hidecategories(Object,UIRoot);

enum EBadgeStateCondition
{
    EBSC_Level,
    EBSC_PrestigeLevel,
    EBSC_Stat,
    EBSC_MAX
};

enum EBadgeStateTarget
{
    EBST_Mesh,
    EBST_LocalFX,
    EBST_TPFX,
    EBST_MAX
};

struct native BadgeStateData
{
    var FoxDataProvider_Gear_Badge.EBadgeStateTarget Target;
    var FoxDataProvider_Gear_Badge.EBadgeStateCondition Condition;
    var string StatName;
    var int IntRequirement;
    var int FloatRequirement;
    var int Priority;
    var string MAssetPath;
    var string FAssetPath;
    var name LocalFXSocketName;
    var string LocalFXParticleSystemPath;
    var name TPPawnFXBoneName;
    var string TPPawnFXParticleSystemPath;
    var Rotator TPPawnFXMaleRotation;
    var Rotator TPPawnFXFemaleRotation;
    var Vector TPPawnFXMaleLocation;
    var Vector TPPawnFXFemaleLocation;

    structdefaultproperties
    {
        Target=EBadgeStateTarget.EBST_Mesh
        Condition=EBadgeStateCondition.EBSC_Level
        StatName=""
        IntRequirement=0
        FloatRequirement=0
        Priority=0
        MAssetPath=""
        FAssetPath=""
        LocalFXSocketName=None
        LocalFXParticleSystemPath=""
        TPPawnFXBoneName=None
        TPPawnFXParticleSystemPath=""
        TPPawnFXMaleRotation=(Pitch=0,Yaw=0,Roll=0)
        TPPawnFXFemaleRotation=(Pitch=0,Yaw=0,Roll=0)
        TPPawnFXMaleLocation=(X=0.0,Y=0.0,Z=0.0)
        TPPawnFXFemaleLocation=(X=0.0,Y=0.0,Z=0.0)
    }
};

var const config array<config BadgeStateData> ConditionalStates;

// Export UFoxDataProvider_Gear_Badge::execMeetsCondition(FFrame&, void* const)
native function bool MeetsCondition(int ConditionalStatesIndex, FoxPRI PRI);

function int GetBestConditionalState(FoxDataProvider_Gear_Badge.EBadgeStateTarget Target, FoxPRI PRI)
{
    local int I, BestIndex, BestPriority;

    BestIndex = -1;
    BestPriority = -9999;
    I = 0;
    J0x29:
    // End:0x11F [Loop If]
    if(I < ConditionalStates.Length)
    {
        // End:0x111
        if((ConditionalStates[I].Target == Target) && ConditionalStates[I].Priority > BestPriority)
        {
            // End:0x111
            if(MeetsCondition(I, PRI))
            {
                BestIndex = I;
                BestPriority = ConditionalStates[I].Priority;
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x29;
    }
    return BestIndex;
    //return ReturnValue;    
}

function SkeletalMesh GetSkelMeshAsset(bool bIsFemale, FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(0, PRI);
    // End:0x13B
    if(BestIndex >= 0)
    {
        // End:0xB3
        if(!bIsFemale && ConditionalStates[BestIndex].MAssetPath != "")
        {
            return SkeletalMesh(DynamicLoadObject(ConditionalStates[BestIndex].MAssetPath, class'SkeletalMesh', false));
        }
        // End:0x138
        else
        {
            // End:0x136
            if(bIsFemale && ConditionalStates[BestIndex].FAssetPath != "")
            {
                return SkeletalMesh(DynamicLoadObject(ConditionalStates[BestIndex].FAssetPath, class'SkeletalMesh', false));
            }
            // End:0x138
            else
            {
                return none;
            }
        }
    }
    // End:0x159
    else
    {
        return super.GetSkelMeshAsset(bIsFemale, PRI);
    }
    //return ReturnValue;    
}

function StaticMesh GetStaticMeshAsset(bool bIsFemale, FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(0, PRI);
    // End:0x13B
    if(BestIndex >= 0)
    {
        // End:0xB3
        if(!bIsFemale && ConditionalStates[BestIndex].MAssetPath != "")
        {
            return StaticMesh(DynamicLoadObject(ConditionalStates[BestIndex].MAssetPath, class'StaticMesh', false));
        }
        // End:0x138
        else
        {
            // End:0x136
            if(bIsFemale && ConditionalStates[BestIndex].FAssetPath != "")
            {
                return StaticMesh(DynamicLoadObject(ConditionalStates[BestIndex].FAssetPath, class'StaticMesh', false));
            }
            // End:0x138
            else
            {
                return none;
            }
        }
    }
    // End:0x159
    else
    {
        return super.GetStaticMeshAsset(bIsFemale, PRI);
    }
    //return ReturnValue;    
}

function ParticleSystem GetLocalFXParticleSystemAsset(FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(1, PRI);
    // End:0xDD
    if(BestIndex >= 0)
    {
        // End:0xD8
        if((ConditionalStates[BestIndex].LocalFXSocketName != 'None') && ConditionalStates[BestIndex].LocalFXParticleSystemPath != "")
        {
            return ParticleSystem(DynamicLoadObject(ConditionalStates[BestIndex].LocalFXParticleSystemPath, class'ParticleSystem', false));
        }
        // End:0xDA
        else
        {
            return none;
        }
    }
    // End:0xF1
    else
    {
        return super(FoxDataProvider_Unlockable).GetLocalFXParticleSystemAsset(PRI);
    }
    //return ReturnValue;    
}

function name GetLocalFXSocketName(FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(1, PRI);
    // End:0x58
    if(BestIndex >= 0)
    {
        return ConditionalStates[BestIndex].LocalFXSocketName;
    }
    // End:0x6C
    else
    {
        return super(FoxDataProvider_Unlockable).GetLocalFXSocketName(PRI);
    }
    //return ReturnValue;    
}

function ParticleSystem GetTPPawnFXParticleSystemAsset(FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(2, PRI);
    // End:0xDD
    if(BestIndex >= 0)
    {
        // End:0xD8
        if((ConditionalStates[BestIndex].TPPawnFXBoneName != 'None') && ConditionalStates[BestIndex].TPPawnFXParticleSystemPath != "")
        {
            return ParticleSystem(DynamicLoadObject(ConditionalStates[BestIndex].TPPawnFXParticleSystemPath, class'ParticleSystem', false));
        }
        // End:0xDA
        else
        {
            return none;
        }
    }
    // End:0xF1
    else
    {
        return super(FoxDataProvider_Unlockable).GetTPPawnFXParticleSystemAsset(PRI);
    }
    //return ReturnValue;    
}

function name GetTPPawnFXBoneName(FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(2, PRI);
    // End:0x58
    if(BestIndex >= 0)
    {
        return ConditionalStates[BestIndex].TPPawnFXBoneName;
    }
    // End:0x6C
    else
    {
        return super(FoxDataProvider_Unlockable).GetTPPawnFXBoneName(PRI);
    }
    //return ReturnValue;    
}

function Rotator GetTPPawnFXRotation(bool bFemale, FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(2, PRI);
    // End:0x8F
    if(BestIndex >= 0)
    {
        // End:0x65
        if(bFemale)
        {
            return ConditionalStates[BestIndex].TPPawnFXFemaleRotation;
        }
        // End:0x8C
        else
        {
            return ConditionalStates[BestIndex].TPPawnFXMaleRotation;
        }
    }
    // End:0xAD
    else
    {
        return super(FoxDataProvider_Unlockable).GetTPPawnFXRotation(bFemale, PRI);
    }
    //return ReturnValue;    
}

function Vector GetTPPawnFXLocation(bool bFemale, FoxPRI PRI)
{
    local int BestIndex;

    BestIndex = GetBestConditionalState(2, PRI);
    // End:0x8F
    if(BestIndex >= 0)
    {
        // End:0x65
        if(bFemale)
        {
            return ConditionalStates[BestIndex].TPPawnFXFemaleLocation;
        }
        // End:0x8C
        else
        {
            return ConditionalStates[BestIndex].TPPawnFXMaleLocation;
        }
    }
    // End:0xAD
    else
    {
        return super(FoxDataProvider_Unlockable).GetTPPawnFXLocation(bFemale, PRI);
    }
    //return ReturnValue;    
}
